Package org.tanukisoftware.wrapper.jmx

# Interface WrapperManagerMBean

All Known Implementing Classes:
  `WrapperManager`

public interface WrapperManagerMBean

## Method Summary

Modifier and Type
Method
Description
`String`
`getBuildTime()`
Obtain the build time of Wrapper.
`boolean`
`getHasShutdownHookBeenTriggered()`
Returns true if the ShutdownHook for the JVM has already been triggered.
`int`
`getJavaPID()`
Returns the PID of the Java process.
`int`
`getJVMId()`
Returns the Id of the current JVM.
`String`
`getVersion()`
Obtain the current version of Wrapper.
`int`
`getWrapperPID()`
Returns the PID of the Wrapper process.
`boolean`
`isControlledByNativeWrapper()`
Returns true if the JVM was launched by the Wrapper application.
`boolean`
`isDebugEnabled()`
Returns true if the wrapper.debug property, or any of the logging channels are set to DEBUG in the wrapper configuration file.
`boolean`
`isLaunchedAsService()`
Returns true if the Wrapper was launched as an NT service on Windows or as a daemon process on UNIX platforms.
`boolean`
`isProfessionalEdition()`
Returns true if the current Wrapper edition has support for Professional Edition features.
`boolean`
`isStandardEdition()`
Returns true if the current Wrapper edition has support for Standard Edition features.
`void`
`requestThreadDump()`
Requests that the current JVM process request a thread dump.
`void`
`restart()`
Tells the native wrapper that the JVM wants to restart, then informs all listeners that the JVM is about to shutdown before killing the JVM.
`void`
`setConsoleTitle(String title)`
Sets the title of the console in which the Wrapper is running.
`void`
`stop(int exitCode)`
Tells the native wrapper that the JVM wants to shut down, then informs all listeners that the JVM is about to shutdown before killing the JVM.

## Method Details

### getVersion

String getVersion()
Obtain the current version of Wrapper.

Returns:
  The version of the Wrapper.

### getBuildTime

String getBuildTime()
Obtain the build time of Wrapper.

Returns:
  The time that the Wrapper was built.

### getJVMId

int getJVMId()
Returns the Id of the current JVM. JVM Ids increment from 1 each time the wrapper restarts a new one.

Returns:
  The Id of the current JVM.

### isProfessionalEdition

boolean isProfessionalEdition()
Returns true if the current Wrapper edition has support for Professional Edition features.

Returns:
  True if professional features are supported.

### isStandardEdition

boolean isStandardEdition()
Returns true if the current Wrapper edition has support for Standard Edition features.

Returns:
  True if standard features are supported.

### setConsoleTitle

void setConsoleTitle(String title)
Sets the title of the console in which the Wrapper is running. This is currently only supported on Windows platforms.

As an alternative, it is also possible to set the console title from within the wrapper.conf file using the wrapper.console.title property.

Parameters:
  `title` - The new title. The specified string will be encoded to a byte array using the default encoding for the current platform.

### getWrapperPID

int getWrapperPID()
Returns the PID of the Wrapper process. A PID of 0 will be returned if the JVM was launched standalone. This value can also be obtained using the 'wrapper.pid' system property.

Returns:
  The PID of the Wrpper process.

### getJavaPID

int getJavaPID()
Returns the PID of the Java process. A PID of 0 will be returned if the native library has not been initialized. This value can also be obtained using the 'wrapper.java.pid' system property.

Returns:
  The PID of the Java process.

### requestThreadDump

void requestThreadDump()
Requests that the current JVM process request a thread dump. This is the same as pressing CTRL-BREAK (under Windows) or CTRL-\ (under Unix) in the the console in which Java is running. This method does nothing if the native library is not loaded.

### isControlledByNativeWrapper

boolean isControlledByNativeWrapper()
Returns true if the JVM was launched by the Wrapper application. False if the JVM was launched manually without the Wrapper controlling it.

Returns:
  True if the current JVM was launched by the Wrapper.

### isLaunchedAsService

boolean isLaunchedAsService()
Returns true if the Wrapper was launched as an NT service on Windows or as a daemon process on UNIX platforms. False if launched as a console. This can be useful if you wish to display a user interface when in Console mode. On UNIX platforms, this is not as useful because an X display may not be visible even if launched in a console.

Returns:
  True if the Wrapper is running as an NT service or daemon process.

### isDebugEnabled

boolean isDebugEnabled()
Returns true if the wrapper.debug property, or any of the logging channels are set to DEBUG in the wrapper configuration file. Useful for deciding whether or not to output certain information to the console.

Returns:
  True if the Wrapper is logging any Debug level output.

### restart

void restart()
Tells the native wrapper that the JVM wants to restart, then informs all listeners that the JVM is about to shutdown before killing the JVM.

The restart is actually performed in a background thread allowing JMX a chance to respond to the client.

### stop

void stop(int exitCode)
Tells the native wrapper that the JVM wants to shut down, then informs all listeners that the JVM is about to shutdown before killing the JVM.

The stop is actually performed in a background thread allowing JMX a chance to respond to the client.

Parameters:
  `exitCode` - The exit code that the Wrapper will return when it exits.

### getHasShutdownHookBeenTriggered

boolean getHasShutdownHookBeenTriggered()
Returns true if the ShutdownHook for the JVM has already been triggered. Some code needs to know whether or not the system is shutting down.

Returns:
  True if the ShutdownHook for the JVM has already been triggered.